#ifndef CPP_ENROLL_CONTAINER_KEY_OBJECT_H_
#define CPP_ENROLL_CONTAINER_KEY_OBJECT_H_

#include "cppcades.h"
#include <atlcrypt2.h>
#include "CPPCadesCPCertificate.h"

using namespace ATL;
using namespace CryptoPro::PKI::CAdES;

namespace CryptoPro {
namespace PKI {
namespace Enroll {

class CPPEnrollContainerKey
{
public:
    CPPEnrollContainerKey(void);
    ~CPPEnrollContainerKey(void);
    HRESULT get_HasCertificate(BOOL& Val);
    HRESULT get_Certificate(boost::shared_ptr<CPPCadesCPCertificateObject>& pVal);
    HRESULT get_IsExportable(BOOL& Val);
    HRESULT get_Type(DWORD& Val);
    HRESULT get_ExpirationTime(CryptoPro::CDateTime& value);

    //internal use
    HRESULT Initialize(HCRYPTKEY hKey, DWORD dwKeyType);
    void CheckInitialized();

private:
    DISALLOW_COPY_AND_ASSIGN(CPPEnrollContainerKey);
    CCryptUserExKey m_hKey;
    DWORD m_dwKeyType;

};

} /* namespace Enroll */
} /* namespace PKI */
} /* namespace CryptoPro */

#endif // CPP_ENROLL_CONTAINER_KEY_OBJECT_H_
